#!/usr/bin/env bash

if ! [ -f Labels.zip ] ; then
	wget http://www.causality.inf.ethz.ch/al_data/Labels.zip
fi

for data in hiva nova ibn_sina orange sylva zebra; do
	
	if ! [ -f Labels/$data.label ]; then
		yes | unzip Labels.zip
	fi

	if ! [ -f $data.zip ] ; then
		wget http://www.causality.inf.ethz.ch/al_data/$data.zip;
	fi
	
	if ! [ -f $data.data ] ; then
		unzip $data.zip;
	fi

	if ! [ -f $data.correct ] ; then

		make octave;

		cmd="
			[label data] = libsvmread('$data.data');
			label = load('Labels/$data.label');";


		if [ $data = orange ] ; then
			cmd="$cmd
				data = [data isnan(data)];";
		fi

		cmd="$cmd
			data(isnan(data)) = 0;

			%M = max(data);
			%m = min(data);
			
			%data = data(:, M ~= m);";
		
		if [ $data != ibn_sina ] && [ $data != hiva ] && [ $data != nova ]; then
			cmd="$cmd 
				l = size(data, 1);
				m = min(data);
				d = max(data) - m;
				d(d == 0) = 1;
				
				data = (data - repmat(m, l, 1)) ...
					./ repmat(d, l, 1);
				data(isnan(data)) = 1; % Inf/Inf";
		fi

		cmd="$cmd
			libsvmwrite('$data.correct', label, data);";

		octave --eval "$cmd"	
	fi
done
